package pooldemo;

import org.apache.commons.dbutils.*;
import org.apache.commons.dbutils.handlers.*;
import org.apache.ibatis.datasource.pooled.*;
import com.zaxxer.hikari.*;

public class ConPoolApp {
	private static String driver = "com.mysql.cj.jdbc.Driver";
	private static String url = "jdbc:mysql://localhost:3306/test?useSSL=false&useUnicode=true&characterEncoding=UTF-8";
	private static String username = "root";
	private static String password = "";
	
	public static void querySample() throws Exception {
		PooledDataSource dataSource = new PooledDataSource(driver, url, username, password);
		QueryRunner run = new QueryRunner(dataSource);
		ResultSetHandler<User> handlerBean = new BeanHandler<User>(User.class);
		User result = run.query("select * from user where id=?", handlerBean, 1);
		System.out.println(result);
		dataSource.forceCloseAll();
	}
	
	public static HikariDataSource getHikariCP() {
		HikariConfig config = new HikariConfig();
		config.setJdbcUrl(url);
		config.addDataSourceProperty("user", username);
		config.addDataSourceProperty("password", password);
		config.addDataSourceProperty("cachePrepStmts", "true");
		config.addDataSourceProperty("prepStmtCacheSize", "250");
		config.addDataSourceProperty("prepStmtCacheSqlLimit", "2048");
		HikariDataSource ds = new HikariDataSource(config);
		return ds;
	}
	
	public static void querySampleHikariCP() throws Exception {
		HikariDataSource dataSource = getHikariCP();
		QueryRunner run = new QueryRunner(dataSource);
		ResultSetHandler<User> handlerBean = new BeanHandler<User>(User.class);
		User result = run.query("select * from user where id=?", handlerBean, 1);
		System.out.println(result);
		dataSource.close();
	}
	
	public static void main(String[] args) throws Exception {
		querySample();
		querySampleHikariCP();
	}
}

